package yui.example.datavisualization.helper
{
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.printing.PrintJob;
	import flash.printing.PrintJobOptions;
	
	import mx.charts.chartClasses.CartesianChart;
	import mx.controls.DataGrid;
	import mx.core.Application;
	import mx.graphics.ImageSnapshot;
	
	import org.seasar.akabana.yui.logging.LogManager;
	import org.seasar.akabana.yui.logging.Logger;
	
	import yui.example.datavisualization.view.ExampleView;
	
	public class ExampleHelper
	{
		public var logger:Logger = LogManager.getLogger( ExampleHelper );
		
		public var view:ExampleView;
		
		private var printJob:PrintJob;
		
		public function setupView( value:Array ):void
		{
			view.linechart.dataProvider = value;
			view.datagrid.dataProvider = value;
		}
		
		public function print():void
		{
			var chart:CartesianChart = view.linechart;
			var datagrid:DataGrid = view.datagrid;
			
			if ( printJob == null ) 
			{
                printJob = new PrintJob();

				var chartBD:BitmapData = ImageSnapshot.
						captureBitmapData( chart, null, null, null, null, true );
						
				var datagridBD:BitmapData = ImageSnapshot.
						captureBitmapData( datagrid, null, null, null, null, true );
						
	            if ( printJob.start() ) 
	            {
					var chartsprite:Sprite = new Sprite();
					drawBitmapData( chartsprite, chartBD );
					
					chartsprite.scaleX = 
		            	chartsprite.scaleY = 
		            		printJob.pageWidth / chartsprite.width;
		            		
					var datagridsprite:Sprite = new Sprite();
					datagridsprite.y = chartsprite.height;
					drawBitmapData( datagridsprite, datagridBD );
					 
		            datagridsprite.scaleX = 
		            	datagridsprite.scaleY = 
		            		printJob.pageWidth / datagridsprite.width;
					
					var sprite:Sprite = new Sprite();
	            	sprite.visible = false;
					sprite.graphics.clear();
					sprite.graphics.beginFill( 0xFFFFFF );
					sprite.graphics.drawRect( 0, 0, printJob.pageWidth, printJob.pageHeight );
					sprite.graphics.endFill();

		            sprite.addChild( chartsprite );
		            sprite.addChild( datagridsprite );

					Application.application.stage.addChild( sprite );
		            		            		
                    printJob.addPage( sprite, null, new PrintJobOptions( true ) );
                	printJob.send();
                	
                	Application.application.stage.removeChild( sprite );
                }
                printJob = null;					 
            }
		}
		
		private function drawBitmapData( sprite:Sprite, bd:BitmapData ):void
		{
			if ( sprite != null && bd != null )
			{
				sprite.graphics.beginBitmapFill( bd, null, false, true );
	            sprite.graphics.drawRect(0, 0, bd.width, bd.height );
	            sprite.graphics.endFill();
			}
		}
		
	}
}